#import es, if we don't we have no access to game variables and events. os.path is the path to our script ;)
import es, os.path

#this is all for the upcoming es_update command.
info = es.AddonInfo()
#lets set the name of the addon.
info.name = 'Hitsounds'
#be sure to always edit the version when releasing a new version of the addon.
info.version = '1.0'
#where is it located.
info.url = 'http:forums.mattie.info/cs/forums/'
#the es_load name.
info.basename = 'hitsounds'
#of course you need the author name .
info.author = 'TaCo'

#these are the defaults, thanks to freddukes for his config code 
dict_options = {
'hs_hit':  ['shot.wav',   'The file name in cstrike/sound/hitsounds/ that plays when a player shoots another player'],
'hs_headshot':  ['headshot.wav',   'The file name in cstrike/sound/hitsounds/ that plays when a player gets a headshot'],
'hs_kill':  ['kill.wav',   'The file name in cstrike/sound/hitsounds/ that plays when a player kills another player'],
'hs_knife':  ['kill.wav',   'The file name in cstrike/sound/hitsounds/ that plays when a player throws a grenade and it damages another player'],
'hs_no':  ['no.wav',   'The file name in cstrike/sound/hitsounds/ that plays when a player knifes another player']
}

def load():
	#lets create Server Variables out of all our options so that we can fill them in later if there diffrent.
	for option in dict_options:
		#this will go through our list and set the 
		es.ServerVar(option, dict_options[option][0], dict_options[option][1])
	
	#lets load the config!
	configpath = es.getAddonPath('hitsounds') + '/config.cfg'
	#check if its there
	if os.path.isfile(configpath):
		#if so, continue.
		es.server.cmd('es_xmexec ../addons/eventscripts/hitsounds/config.cfg')
		es.dbgmsg(0,'[HITSOUNDS]Loading HitSounds sound files ...')
	else:
		#if not send an error in console
		es.dbgmsg(0,'[HITSOUNDS]Unable to load config.cfg! Please ensure it is in the ../hitsounds/ directory.')
	#make our files usable in every event
	global hs_files
	#so its easy for me i created a list of files
	hs_files = [es.ServerVar('hs_hit'), es.ServerVar('hs_headshot'), es.ServerVar('hs_kill'), es.ServerVar('hs_knife'), es.ServerVar('hs_no')]
	#this is useful because it adds all the sounds to the downloadable list
	for hs in hs_files:
		es.stringtable('downloadables', 'sound/hitsounds/%s'%hs)
		es.dbgmsg(0,'[HITSOUNDS]Added %s to the downloadable list.'%hs)

def es_map_start(event_var):
	#the next map after its loaded make sure its loaded
	for hs in hs_files:
		es.stringtable('downloadables', 'sound/hitsounds/%s'%hs)
		
def player_hurt(event_var):
	#lets shorten things up
	attacker = event_var['attacker']
	weapon = event_var['es_attackerweapon']
	
	#Lets make sure that there not attacking team mates
	if event_var['es_attackerteam'] == event_var['es_userteam']:
		PlaySound(attacker, hs_files[4])
	#if this isnt true, proceed
	else: 
		#lets check for special events.
		if event_var['es_attackerweapon'] == 'weapon_knife':
			PlaySound(attacker, hs_files[3])
		#if not proceed.
		#if you made it this far your useing a rifle or pistol on your enemy!
		else:
			#this will tell if we have a headshot.
			if event_var['hitgroup'] == '1':
				PlaySound(attacker, hs_files[1])
			#if not send a 'body hit' sound to them
			else:
				PlaySound(attacker, hs_files[0])
				
def player_death(event_var):
	attacker = event_var['attacker']
	#when the player dies play this sound to his killer
	PlaySound(attacker, hs_files[2])
	
def hostage_hurt(event_var):
	attacker = event_var['attacker']
	#play this sound when they are not supposed to be attacking hostages
	PlaySound(attacker, hs_files[4])

#we will create a 'command' of sorts. this 'class' will allow us when it is called, to get information and play a sound off of it
class PlaySound:
	#this will get the arguments and store them in variables
	def __init__(self, attacker, sound):
		#now we use these variables to play sound
		es.cexec(attacker,'play', "hitsounds/%s"%sound)